WebBase_PFIncorporation/Controllers/Cliente/InicioController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using NLog.Layouts;
using Services.IServices;

namespace BaseWeb_PFIncorporation.Controllers.Cliente
{
    
    [AllowAnonymous]
    [Layout("_HomeLayout")]
    public class InicioController : Controller
    {
        private readonly IProductoServices _productoServices;
        private readonly ICategoriasServices _categoriasServices;
        public InicioController(IProductoServices producto, ICategoriasServices categoriasServices)
        {
            _productoServices = producto;
            _categoriasServices = categoriasServices;
        }
        // GET: Inicio
        public async Task<IActionResult> Index()
        {
            var listas = await _productoServices.listaProductoViewModel();
            return View(listas);
        }
        public ActionResult ContactoCliente()
        {
            return View();
        }

        public async Task<IActionResult> Productos()
        {
            var categorias = await _categoriasServices.obtenerLista();
            ViewBag.Categorias = categorias.Any() ? new SelectList(categorias, "Id", "Nombre") : null;
            return View();
        }
        [HttpGet]
        public async Task<IActionResult> _ProductosCategorias(int id)
        {
            if (id <=0 )
            {
                var lista = await _productoServices.obtenerLista();
                return PartialView(lista);
            }
            else
            {
                var categorias = await _productoServices.ObtenerListaPCategoria(id);
                return PartialView(categorias);
            }
             

        }
        public async Task<IActionResult> Detalles(int id)
        {
            var producto = await _productoServices.buscarPorId(id);
            ViewBag.id = id;
            return View(producto);
        }

        // GET: Inicio/Details/5
        public async Task<IActionResult> Details(int id)
        {
            var producto = await _productoServices.buscarPorId(id);
            return View(producto);
        }

        // GET: Inicio/Create
        public ActionResult Create()
        {
            return View();
        }

        // POST: Inicio/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create(IFormCollection collection)
        {
            try
            {
                // TODO: Add insert logic here

                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: Inicio/Edit/5
        public ActionResult Edit(int id)
        {
            return View();
        }

        // POST: Inicio/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit(int id, IFormCollection collection)
        {
            try
            {
                // TODO: Add update logic here

                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: Inicio/Delete/5
        public ActionResult Delete(int id)
        {
            return View();
        }

        // POST: Inicio/Delete/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Delete(int id, IFormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here

                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }
    }
}

WebBase_PFIncorporation/Controllers/ProductosController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Domain.Ejemplo;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Services.IServices;

namespace BaseWeb_PFIncorporation.Controllers
{
    public class ProductosController : Controller
    {
        private readonly IProductoServices _productoServices;
        private readonly ICategoriasServices _categoriasServices;
        public ProductosController(IProductoServices productoServices, ICategoriasServices categoriasServices)
        {
            _productoServices = productoServices;
            _categoriasServices = categoriasServices;
        }
        // GET: ProductosController
        public async  Task<IActionResult> Index()
        {
            var lista = await  _productoServices.obtenerLista();
            return View(lista);
        }

        // GET: ProductosController/Details/5
        public async Task<IActionResult> Detalles(int id)
        {
            Producto producto = await _productoServices.buscarPorId(id);
            if (producto == null)
            {
                return RedirectToAction("Index");
            }
            return View(producto);
        }

        // GET: ProductosController/Create
        public async Task<IActionResult> Crear()
        {
            var categorias = await _categoriasServices.obtenerLista();
            ViewBag.Categorias= categorias.Any()? new  SelectList(categorias, "Id","Nombre"): null;
            return View();
        }

        // POST: ProductosController/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async  Task<IActionResult> Crear(Producto producto)
        {
            if (ModelState.IsValid)
            {
                var response = await _productoServices.crear(producto);
                if (response.Success) // Validamos sí la unidad de medida se creó.
                {
                    //return Json(new { success = response.Success, msj = response.Message });
                    TempData["Success"] = response.Message;
                    return RedirectToAction("Index");
                }
                else
                {
                    TempData["Error"] = response.Message;
                    return View(producto);
                }
            }
            TempData["Error"] = "¡Verifica que los datos esten completos y sean correctos, si el problema continua comunicate con el administrador!";
            return RedirectToAction("Index");
           

        }

        // GET: ProductosController/Edit/5
        public async Task<ActionResult> Editar (int Id)
        {
            var producto = await _productoServices.buscarPorId(Id);
            if (producto != null)
            {
                var categorias = await _categoriasServices.obtenerLista();
                ViewBag.Categorias = categorias.Any() ? new SelectList(categorias, "Id", "Nombre") : null;
                return View(producto);
            }
            return RedirectToAction("Index");
        }

        // POST: ProductosController/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async  Task<ActionResult> Editar(Producto producto)
        {
            if (ModelState.IsValid)
            {
                var response = await _productoServices.editar(producto);
                if (response.Success) // Validamos sí la unidad de medida se creó.
                {
                    //return Json(new { success = response.Success, msj = response.Message });
                    TempData["Success"] = response.Message;
                    return RedirectToAction("Index");
                }
                else
                {
                    TempData["Error"] = response.Message;
                    var categorias = await _categoriasServices.obtenerLista();
                    ViewBag.Categorias = categorias.Any() ? new SelectList(categorias, "Id", "Nombre") : null;
                    return View(producto);
                }
            }
            TempData["Error"] = "¡Verifica que los datos esten completos y sean correctos, si el problema continua comunicate con el administrador!";
            return RedirectToAction("Index");
        }

        // GET: ProductosController/Delete/5
        public ActionResult Delete(int id)
        {
            return View();
        }

        // POST: ProductosController/Delete/5
        
        public async Task<IActionResult> EliminarConfirmado(int id)
        {
            if ( id <= 0) // Validamos que el id no sea nulo o que contenga un valor negativo.
            {
                return RedirectToAction("Index");
            }
            var response = await _productoServices.eliminar(id);
            if (response.Success) // Validamos sí el producto se eliminó.
            {
                return Json(new { success = response.Success, msj = response.Message });
            }
            else
            {
                ModelState.AddModelError("modelError", response.Message);
                return Json(new { success = response.Success, msj = response.Message });
            }
        }
        //[HttpGet]
        //public ActionResult ProductoIma(int Id)
        //{

        //}
        [HttpGet]
        public async Task<IActionResult> ProductoIma(int id)
        {
            ViewBag.id = id;
            return View();
        }
        [HttpPost]
        public async Task<IActionResult> ProductoIma(List<IFormFile> files, int Id)
        {
            if (ModelState.IsValid)
            {
                var response = await _productoServices.ProductosImagenes(files, Id);
                if (response.Success) // Validamos sí la unidad de medida se creó.
                {
                    //return Json(new { success = response.Success, msj = response.Message });
                    TempData["Success"] = response.Message;
                    return RedirectToAction("Index");
                }
                else
                {
                    TempData["Error"] = response.Message;
                    var categorias = await _categoriasServices.obtenerLista();
                    ViewBag.Categorias = categorias.Any() ? new SelectList(categorias, "Id", "Nombre") : null;
                    return View();
                }
            }
            TempData["Error"] = "¡Verifica que los datos esten completos y sean correctos, si el problema continua comunicate con el administrador!";
            return RedirectToAction("Index");

        }
    }
}

WebBase_PFIncorporation/Views/Inicio/ContactoCliente.cshtml
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
    ViewData["Title"] = "Contacto";
    Layout = "~/Views/Shared/_HomeLayout.cshtml";
}

    <div class="row">
        <div class="col-md-6">
            
            <div class="col-md-12 k-align-center" style="padding-top:100px">
               <div class="k-blog-post__content ">
                  <h4 class="k-align-center">Cuentanos un poco más...</h4>
                   <div class="k-section">
                                    <label style="font-size:15px; color:#9b9898"><i class="flaticon-email "></i> Correo:<strong>  lordprettyflames@gmail.com</strong></label>

                   </div>

               </div>
                <div>
                   <img style="width:60%; height:50%" src="~/assets/media/icons/PFNUEVOLOGO.png" />
                </div>

            </div>


               
        </div>
        <div class="col-md-6">
            <div class="k-portlet">
                <div class="k-portlet__body">
                    <div class="k-blog-post">
                        <h1 class="k-blog-post__title k-heading k-heading--lg k-heading--medium k-align-center">
                            Contactanos
                        </h1>

                        @*<div class="k-blog-post__hero-image">
                        <img src="../assets/media/blog/1200x600/2.jpg" class="k-blog-post__image">
                    </div>*@
                        <div class="row">
                            @*<div class="col-md-6">
                                <div class="row">
                                    <div class="col-md-12 k-align-center">
                                        <div class="k-blog-post__content ">
                                            <h4 class="k-align-center">Cuentanos un poco más...</h4>
                                            <div class="k-section">
                                                <label style="font-size:15px; color:#9b9898"><i class="flaticon-email "></i> Correo:<strong>  lordprettyflames@gmail.com</strong></label>

                                            </div>

                                        </div>
                                        <div>
                                            <img style="width:50%; height:40%" src="~/assets/media/icons/PFNUEVOLOGO.png" />
                                        </div>

                                    </div>


                                </div>

                            </div>*@
                            <div class="col-md-12">
                                <form>
                                    <div class="row">

                                        <div class="col-md-6">
                                            <label>Nombre</label>
                                            <input type="text" class="form-control" placeholder="Fulanito" />
                                        </div>
                                        <div class="col-md-6">
                                            <label>Apellidos</label>
                                            <input type="text" class="form-control" placeholder="Perez Prado" />
                                        </div>
                                        <div class="col-md-12">
                                            <label>Correo</label>
                                            <input type="email" class="form-control" placeholder="fulanito@gmail.com" />
                                        </div>
                                        <div class="col-md-12">
                                            <label>Mensaje</label>
                                            <textarea class="form-control" rows="4">  </textarea>
                                        </div>

                                    </div>
                                    <div class="modal-footer">
                                        <button type="submit" class="btn btn-primary "> Enviar</button>
                                    </div>

                                </form>


                                @*<div class="k-blog-post__content ">
                                <p>Apart from the objective of your text, your company or your website will have long term business objectives. You should think about those long term business aims while determining the objectives of the text on your website.</p>
                                <p>For instance, at Yoast.com, we write blogposts largely to inform people about SEO. So the objective is to inform people. However, we also want people to become return visitors and to gain trust in our brand. Eventually, the long term purpose of our informing blogs is to gain enough trust for people to buy one of our products.</p>
                                <p>Be aware that if the objective of your post is to generate links from others, you should think about the character of your post as well. If you want your post to attract links from other sites in order to improve your rankings in Google you should focus on writing informative or amusing posts. Persuasive posts, in which the sales arguments are salient, will not receive as many links as purely informative posts will. People are more likely to share an informative or an amusing post than a purely persuasive post, because these posts are more free of ulterior motives.</p>
                            </div>*@
                            </div>

                        </div>


                    </div>
                </div>
            </div>


        </div>

   </div>

WebBase_PFIncorporation/Views/Inicio/Details.cshtml
@model Domain.Ejemplo.Producto
@{
    ViewData["Title"] = "Detalles";
    Layout = "~/Views/Shared/_HomeLayout.cshtml";
    int cont = 0;
    int cont2 = 0;
}

<div class="k-content__body	k-grid__item k-grid__item--fluid" id="k_content_body" style="padding-top:15px">
    <div class="k-portlet">
        <div class="row">
            <div class="col-xl-5 col-lg-5 col-md-6">
                <div id="carousel-example-1" class="single-product-slider carousel slide" data-ride="carousel">
                    <div class="carousel-inner" role="listbox">

                        @foreach (var item in Model.ImagenProducto)
                        {
                            <div class="carousel-item @(cont == 0 ? "active" : "")" style="height: 600px; overflow: hidden;"> <img class="d-block w-100" src="~/Documentos/@item.URL" alt="slide"> </div>
                            cont++;
                        }
                    </div>
                    <a class="carousel-control-prev" href="#carousel-example-1" role="button" data-slide="prev" style="color:black">
                        <i class="fa fa-angle-left" aria-hidden="true"></i>
                        <span class="sr-only">Previous</span>
                    </a>
                    <a class="carousel-control-next" href="#carousel-example-1" role="button" data-slide="next" style="color:black">
                        <i class="fa fa-angle-right" aria-hidden="true"></i>
                        <span class="sr-only">Next</span>
                    </a>
                    <ol class="carousel-indicators" style="background-color:#0000006b;">
                        @foreach (var item in Model.ImagenProducto)
                        {
                            <li data-target="#carousel-example-1" data-slide-to="@cont2" class="@(cont2 == 0 ? "active" : "")" style="height: 40px; overflow: hidden;">
                                <img class="d-block w-100 img-fluid" src="~/Documentos/@item.URL" alt="" />
                            </li>
                            cont2++;
                        }
                    </ol>
                </div>
            </div>
            <div class="col-xl-7 col-lg-6 col-md-5 my-auto">
                <div class="single-product-details">
                    <h2>@Model.Nombre</h2>

                    @if (Model.Descuento)
                    {
                        <h5>
                            <del style="color:#ea5454">$ @Model.precio MXN</del> / $ @Model.PrecioConDescuento MXN ahorra un @Model.PorcentajeDes %
                        </h5>
                    }
                    else
                    {
                        <h5>
                            $ @Model.precio MXN
                        </h5>
                    }

                    <br />
                    <br />
                    <p>
                        <h4>Descripción:</h4>
                    <p>
                        @Model.Descripcion
                    </p>
                    <div class="row">
                        <div class="col-lg-6">
                            <div class="form-group">
                                <label><font color="red">*</font> Talla</label>
                                <select class="form-control k_selectpicker">
                                    <option value="" selected style="display:none">Selecciona una talla</option>
                                    @if (Model.talla_XS > 0)
                                    {
                                        <option value="0">XS</option>
                                    }
                                    else
                                    {
                                        <option value="0" disabled>XS</option>
                                    }
                                    @if (Model.talla_S > 0)
                                    {
                                        <option value="0">S</option>
                                    }
                                    else
                                    {
                                        <option value="0" disabled>S</option>
                                    }
                                    @if (Model.talla_M > 0)
                                    {
                                        <option value="0">M</option>
                                    }
                                    else
                                    {
                                        <option value="0" disabled>M</option>
                                    }
                                    @if (Model.talla_L > 0)
                                    {
                                        <option value="0">L</option>
                                    }
                                    else
                                    {
                                        <option value="0" disabled>L</option>
                                    }
                                </select>
                            </div>
                        </div>
                        <div class="col-6">
                            <div class="form-group quantity-box">
                                <label class="control-label">Cantidad</label>
                                <input class="form-control" value="0" min="0" max="20" type="number">
                            </div>
                        </div>
                    </div>


                    <div class="cart-and-bay-btn" style="text-align:end">
                        <a class="btn btn-md btn-primary" data-fancybox-close="" href="#">Comprar ahora</a>
                        <a class="btn btn-md btn-outline-primary" data-fancybox-close="" href="#">Añadir al carrito</a>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<link href="~/assets/vendors/general/bootstrap-select/dist/css/bootstrap-select.css" rel="stylesheet" type="text/css" />
<link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.2/css/select2.min.css" rel="stylesheet" type="text/css" />

WebBase_PFIncorporation/Views/Inicio/Detalles.cshtml
@model Domain.Ejemplo.Producto
@{
    ViewData["Title"] = "Evidencias";
    Layout = "~/Views/Shared/_HomeLayout.cshtml";
    var Item = ViewBag.Id;
}

<link href="~/assets/vendors/general/dropzone/dist/dropzone.css" rel="stylesheet" />
<link href="~/assets/vendors/general/sweetalert2/dist/sweetalert2.css" rel="stylesheet" type="text/css" />


@if (TempData["Error"] != null)
{
    <div class="alert alert-danger fade show" role="alert">
        <div class="alert-icon"><i class="fa fa-times-circle"></i></div>
        <div class="alert-text"> <strong>¡Error!</strong> @TempData["Error"]</div>
        <div class="alert-close">
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true"><i class="la la-close"></i></span>
            </button>
        </div>
    </div>
}
@if (TempData["Success"] != null)
{
    <div class="alert alert-success fade show" role="alert">
        <div class="alert-icon"><i class="fa fa-check-circle"></i></div>
        <div class="alert-text"><strong>¡Éxito!</strong> @TempData["Success"]</div>
        <div class="alert-close">
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true"><i class="la la-close"></i></span>
            </button>
        </div>
    </div>
}

<!-- begin:: Content Body -->
<div class="k-content__body	k-grid__item k-grid__item--fluid" id="k_content_body">

    <!--begin::Portlet-->
    <div class="k-portlet">
        <div class="k-portlet__head">
            <div class="k-portlet__head-label">
                <h3 class="k-portlet__head-title">Carga de imagenes</h3>
            </div>
        </div>

        <!--begin::Form-->
        <div class="k-portlet__body">

            <p><span style="color:red;">Nota:</span> Para complementar la carga del producto adjunte las imagenes de muestra</p>
            <form id="DropZoneFiddle" class="k-form k-form--label-align-right dropzone dropzone-success dz-clickable" asp-action="ProductoIma" asp-controller="Productos" enctype="multipart/form-data">
                <div class="dropzone-msg dz-message needsclick">
                    <h3 class="dropzone-msg-title">Coloque los archivos aquí o haga clic para subir.</h3>
                    <span class="dropzone-msg-desc">Sólo se permiten archivos .jpeg, .jpg y .png para subir</span>
                </div>
                <div class="fallback">
                    <input name="files" type="file" multiple />
                </div>
                <input id='id' name='id' type='hidden' value="@Item" />
            </form>
        </div>
        <div class="k-portlet__foot">
            <div class="k-form__actions">
                <div class="row">
                    <div class="ml-auto">
                        <button type="submit" class="btn btn-brand" id="submit_"><i class="la la-check"></i>Guardar</button>
                        <a asp-controller="Expedientes" asp-action="BuscadorExpedientesFuncionario" class="btn btn-secondary"><i class="la la-arrow-left"></i><span class="k-hidden-mobile">Ir a Productos</span></a>
                    </div>
                </div>
            </div>
        </div>
        <!--end::Form-->
    </div>

    <!--end::Portlet-->
</div>
<!-- end:: Content Body -->
@section Scripts{
    <script src="~/assets/vendors/general/sweetalert2/dist/sweetalert2.min.js" type="text/javascript"></script>
    <script src="~/assets/vendors/custom/theme/framework/vendors/sweetalert2/init.js" type="text/javascript"></script>
    <script src="~/assets/demo/default/custom/components/extended/sweetalert2.js" type="text/javascript"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/dropzone/5.5.1/dropzone.js" integrity="sha256-awEOL+kdrMJU/HUksRrTVHc6GA25FvDEIJ4KaEsFfG4=" crossorigin="anonymous"></script>
    <script>

        function myParamName() {
            return "files";
        }
        var id = $("#id").val();

        var theFile;
        Dropzone.options.DropZoneFiddle = {
            uploadMultiple: true,
            paramName: myParamName,
            clickable: true,
            maxFiles: 10,
            maxFilesize: 7, //in mb
            autoProcessQueue: false,
            parallelUploads: 100,
            addRemoveLinks: true,
            acceptedFiles: ".jpeg,.jpg,.png",
            dictRemoveFile: "Remover archivo",
            dictDefaultMessage: "Sube tus archivos aquí",
            dictMaxFilesExceeded: "Limite de archivos superado, este archivo no se subirá.",
            init: function () {
                var wrapperThis = this;
                var submitButton = document.querySelector("#submit_");
                submitButton.addEventListener("click", function (e) {
                    var numF = wrapperThis.files.length;

                    //console.log("submitted");
                    //console.log(e);
                    e.preventDefault();
                    e.stopPropagation();
                    e.stopImmediatePropagation();

                    if (numF > 0) {
                        wrapperThis.processQueue();
                    } else {
                        swal({
                            type: 'warning',
                            title: 'Advertencia',
                            text: "¡Parar poder procesar esta petición, debe adjuntar al menos un archivo!",
                            allowOutsideClick: false,
                            confirmButtonColor: '#0c7cd5',
                            allowEscapeKey: false
                        });
                    }

                    return false;
                });

                this.on("success", function (file, responseText) {
                    swal({
                        type: 'success',
                        title: 'Carga de Archivos Exitosa',
                        text: "¡Todos los documentos se han subido correctamente!",
                        allowOutsideClick: false,
                        confirmButtonColor: '#0c7cd5',
                        allowEscapeKey: false
                    }).then(function () {
                        window.location.href = "/Productos";
                    });
                });
                this.on("addedfile", function (file) {
                    //alert('Added');
                    console.log('added file');
                    console.log(file);
                });
                this.on('sendingmultiple', function (data, xhr, formData) {
                    console.log('sending multiple');
                    console.log(data);

                });
            }
        };

    </script>
}

WebBase_PFIncorporation/Views/Inicio/_ProductosCategorias.cshtml
@model IEnumerable<Domain.Ejemplo.Producto>

<br />
<br />

<div class="row">
    @foreach (var item in Model)
    {
        <div class="col-4 col-md-3">
            <div class="card mb-2" style="height: 404px;">
                @if (item.ImagenProducto.Count() > 0)
                {


                    <div style="height:200px; overflow:hidden;">

                        <img class="card-img-top" src="~/Documentos/Productos/@item.Nombre/@item.ImagenProducto.First().Nombre" style="margin-top:-15%" alt="Card image cap">
                    </div>
                }
                else
                {
                    <div style="height:200px; overflow:hidden;">

                        <img class="card-img-top" src="~/assets/media/users/puzzle.png" style="margin-top:-15%" alt="Card image cap">
                    </div>

                }
                <div class="card-body">
                    @if (item.Descuento == true)
                    {
                        <div class="ribbon-wrapper">
                            <div class="ribbon bg-primary" style="color: white">
                                @item.PorcentajeDes%
                            </div>
                        </div>
                    }
                    <h4 class="card-title font-weight-bold">@item.Nombre</h4>
                    <p class="card-text">
                        @item.Descripcion
                    </p>

                </div>
                <div class="card-footer" style="text-align: end; background-color:white">
                    <a class="btn btn-primary btn-sm btn-rounded" style="color: white" asp-route-id="@item.Id" asp-action="Details">+ info</a>
                </div>
            </div>
        </div>

    }


</div>